---
title: Contributing
hide_title: false
hide_table_of_contents: false
description: Contribution Guide
keywords:
- docs
- bubbly
- contributing
---

## Contributing
### Style Guide
* Bubbly follows traditional `go` style standards using `gofmt`
* All code should be free from errors when running `golint` and `go vet`
### Reporting a Bug
* When reporting a bug, be sure to be as descriptive as possible
* If you are opening a bug, be sure to include all the steps necessary to reproduce the bug
* Describe the expected behavior vs the actual outcome
* Use Tags to help categorize the issue
* If possible, include a screenshot or stacktrace
### Submitting a feature request or enhancement
* Check to make sure that there isn't already an existing request
* Use a descriptive title
* Explain why this feature or enhancement would be beneficial
### Creating a PR
* Branch all PRs from `main`
* Try to keep PRs as small as possible
* When making a PR, be sure to squash all commits, and have a short but informative description
### Code of Conduct
At Bubbly, we aim to create an open and inclusive work environment. As this is a project written primarily in Go,
we have decided to adopt the community's policies to ensure a positive community. By participating in Bubbly, you agree
to the terms listed [here](https://golang.org/conduct).