// Code generated by entc, DO NOT EDIT.

package codeissue

import (
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"github.com/valocode/bubbly/ent/predicate"
)

// ID filters vertices based on their ID field.
func ID(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDEQ applies the EQ predicate on the ID field.
func IDEQ(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldID), id))
	})
}

// IDNEQ applies the NEQ predicate on the ID field.
func IDNEQ(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldID), id))
	})
}

// IDIn applies the In predicate on the ID field.
func IDIn(ids ...int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(ids) == 0 {
			s.Where(sql.False())
			return
		}
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.In(s.C(FieldID), v...))
	})
}

// IDNotIn applies the NotIn predicate on the ID field.
func IDNotIn(ids ...int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(ids) == 0 {
			s.Where(sql.False())
			return
		}
		v := make([]interface{}, len(ids))
		for i := range v {
			v[i] = ids[i]
		}
		s.Where(sql.NotIn(s.C(FieldID), v...))
	})
}

// IDGT applies the GT predicate on the ID field.
func IDGT(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldID), id))
	})
}

// IDGTE applies the GTE predicate on the ID field.
func IDGTE(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldID), id))
	})
}

// IDLT applies the LT predicate on the ID field.
func IDLT(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldID), id))
	})
}

// IDLTE applies the LTE predicate on the ID field.
func IDLTE(id int) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldID), id))
	})
}

// RuleID applies equality check predicate on the "rule_id" field. It's identical to RuleIDEQ.
func RuleID(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldRuleID), v))
	})
}

// Message applies equality check predicate on the "message" field. It's identical to MessageEQ.
func Message(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldMessage), v))
	})
}

// RuleIDEQ applies the EQ predicate on the "rule_id" field.
func RuleIDEQ(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldRuleID), v))
	})
}

// RuleIDNEQ applies the NEQ predicate on the "rule_id" field.
func RuleIDNEQ(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldRuleID), v))
	})
}

// RuleIDIn applies the In predicate on the "rule_id" field.
func RuleIDIn(vs ...string) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldRuleID), v...))
	})
}

// RuleIDNotIn applies the NotIn predicate on the "rule_id" field.
func RuleIDNotIn(vs ...string) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldRuleID), v...))
	})
}

// RuleIDGT applies the GT predicate on the "rule_id" field.
func RuleIDGT(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldRuleID), v))
	})
}

// RuleIDGTE applies the GTE predicate on the "rule_id" field.
func RuleIDGTE(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldRuleID), v))
	})
}

// RuleIDLT applies the LT predicate on the "rule_id" field.
func RuleIDLT(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldRuleID), v))
	})
}

// RuleIDLTE applies the LTE predicate on the "rule_id" field.
func RuleIDLTE(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldRuleID), v))
	})
}

// RuleIDContains applies the Contains predicate on the "rule_id" field.
func RuleIDContains(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldRuleID), v))
	})
}

// RuleIDHasPrefix applies the HasPrefix predicate on the "rule_id" field.
func RuleIDHasPrefix(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldRuleID), v))
	})
}

// RuleIDHasSuffix applies the HasSuffix predicate on the "rule_id" field.
func RuleIDHasSuffix(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldRuleID), v))
	})
}

// RuleIDEqualFold applies the EqualFold predicate on the "rule_id" field.
func RuleIDEqualFold(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldRuleID), v))
	})
}

// RuleIDContainsFold applies the ContainsFold predicate on the "rule_id" field.
func RuleIDContainsFold(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldRuleID), v))
	})
}

// MessageEQ applies the EQ predicate on the "message" field.
func MessageEQ(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldMessage), v))
	})
}

// MessageNEQ applies the NEQ predicate on the "message" field.
func MessageNEQ(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldMessage), v))
	})
}

// MessageIn applies the In predicate on the "message" field.
func MessageIn(vs ...string) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldMessage), v...))
	})
}

// MessageNotIn applies the NotIn predicate on the "message" field.
func MessageNotIn(vs ...string) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldMessage), v...))
	})
}

// MessageGT applies the GT predicate on the "message" field.
func MessageGT(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.GT(s.C(FieldMessage), v))
	})
}

// MessageGTE applies the GTE predicate on the "message" field.
func MessageGTE(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.GTE(s.C(FieldMessage), v))
	})
}

// MessageLT applies the LT predicate on the "message" field.
func MessageLT(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.LT(s.C(FieldMessage), v))
	})
}

// MessageLTE applies the LTE predicate on the "message" field.
func MessageLTE(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.LTE(s.C(FieldMessage), v))
	})
}

// MessageContains applies the Contains predicate on the "message" field.
func MessageContains(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.Contains(s.C(FieldMessage), v))
	})
}

// MessageHasPrefix applies the HasPrefix predicate on the "message" field.
func MessageHasPrefix(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.HasPrefix(s.C(FieldMessage), v))
	})
}

// MessageHasSuffix applies the HasSuffix predicate on the "message" field.
func MessageHasSuffix(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.HasSuffix(s.C(FieldMessage), v))
	})
}

// MessageEqualFold applies the EqualFold predicate on the "message" field.
func MessageEqualFold(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EqualFold(s.C(FieldMessage), v))
	})
}

// MessageContainsFold applies the ContainsFold predicate on the "message" field.
func MessageContainsFold(v string) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.ContainsFold(s.C(FieldMessage), v))
	})
}

// SeverityEQ applies the EQ predicate on the "severity" field.
func SeverityEQ(v Severity) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldSeverity), v))
	})
}

// SeverityNEQ applies the NEQ predicate on the "severity" field.
func SeverityNEQ(v Severity) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldSeverity), v))
	})
}

// SeverityIn applies the In predicate on the "severity" field.
func SeverityIn(vs ...Severity) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldSeverity), v...))
	})
}

// SeverityNotIn applies the NotIn predicate on the "severity" field.
func SeverityNotIn(vs ...Severity) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldSeverity), v...))
	})
}

// TypeEQ applies the EQ predicate on the "type" field.
func TypeEQ(v Type) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.EQ(s.C(FieldType), v))
	})
}

// TypeNEQ applies the NEQ predicate on the "type" field.
func TypeNEQ(v Type) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.NEQ(s.C(FieldType), v))
	})
}

// TypeIn applies the In predicate on the "type" field.
func TypeIn(vs ...Type) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.In(s.C(FieldType), v...))
	})
}

// TypeNotIn applies the NotIn predicate on the "type" field.
func TypeNotIn(vs ...Type) predicate.CodeIssue {
	v := make([]interface{}, len(vs))
	for i := range v {
		v[i] = vs[i]
	}
	return predicate.CodeIssue(func(s *sql.Selector) {
		// if not arguments were provided, append the FALSE constants,
		// since we can't apply "IN ()". This will make this predicate falsy.
		if len(v) == 0 {
			s.Where(sql.False())
			return
		}
		s.Where(sql.NotIn(s.C(FieldType), v...))
	})
}

// MetadataIsNil applies the IsNil predicate on the "metadata" field.
func MetadataIsNil() predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.IsNull(s.C(FieldMetadata)))
	})
}

// MetadataNotNil applies the NotNil predicate on the "metadata" field.
func MetadataNotNil() predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s.Where(sql.NotNull(s.C(FieldMetadata)))
	})
}

// HasScan applies the HasEdge predicate on the "scan" edge.
func HasScan() predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(ScanTable, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, ScanTable, ScanColumn),
		)
		sqlgraph.HasNeighbors(s, step)
	})
}

// HasScanWith applies the HasEdge predicate on the "scan" edge with a given conditions (other predicates).
func HasScanWith(preds ...predicate.CodeScan) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		step := sqlgraph.NewStep(
			sqlgraph.From(Table, FieldID),
			sqlgraph.To(ScanInverseTable, FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, ScanTable, ScanColumn),
		)
		sqlgraph.HasNeighborsWith(s, step, func(s *sql.Selector) {
			for _, p := range preds {
				p(s)
			}
		})
	})
}

// And groups predicates with the AND operator between them.
func And(predicates ...predicate.CodeIssue) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for _, p := range predicates {
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Or groups predicates with the OR operator between them.
func Or(predicates ...predicate.CodeIssue) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		s1 := s.Clone().SetP(nil)
		for i, p := range predicates {
			if i > 0 {
				s1.Or()
			}
			p(s1)
		}
		s.Where(s1.P())
	})
}

// Not applies the not operator on the given predicate.
func Not(p predicate.CodeIssue) predicate.CodeIssue {
	return predicate.CodeIssue(func(s *sql.Selector) {
		p(s.Not())
	})
}
