// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"database/sql/driver"
	"errors"
	"fmt"
	"math"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/gitcommit"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/repo"
)

// GitCommitQuery is the builder for querying GitCommit entities.
type GitCommitQuery struct {
	config
	limit      *int
	offset     *int
	unique     *bool
	order      []OrderFunc
	fields     []string
	predicates []predicate.GitCommit
	// eager-loading edges.
	withRepo    *RepoQuery
	withRelease *ReleaseQuery
	withFKs     bool
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Where adds a new predicate for the GitCommitQuery builder.
func (gcq *GitCommitQuery) Where(ps ...predicate.GitCommit) *GitCommitQuery {
	gcq.predicates = append(gcq.predicates, ps...)
	return gcq
}

// Limit adds a limit step to the query.
func (gcq *GitCommitQuery) Limit(limit int) *GitCommitQuery {
	gcq.limit = &limit
	return gcq
}

// Offset adds an offset step to the query.
func (gcq *GitCommitQuery) Offset(offset int) *GitCommitQuery {
	gcq.offset = &offset
	return gcq
}

// Unique configures the query builder to filter duplicate records on query.
// By default, unique is set to true, and can be disabled using this method.
func (gcq *GitCommitQuery) Unique(unique bool) *GitCommitQuery {
	gcq.unique = &unique
	return gcq
}

// Order adds an order step to the query.
func (gcq *GitCommitQuery) Order(o ...OrderFunc) *GitCommitQuery {
	gcq.order = append(gcq.order, o...)
	return gcq
}

// QueryRepo chains the current query on the "repo" edge.
func (gcq *GitCommitQuery) QueryRepo() *RepoQuery {
	query := &RepoQuery{config: gcq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := gcq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := gcq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(gitcommit.Table, gitcommit.FieldID, selector),
			sqlgraph.To(repo.Table, repo.FieldID),
			sqlgraph.Edge(sqlgraph.M2O, false, gitcommit.RepoTable, gitcommit.RepoColumn),
		)
		fromU = sqlgraph.SetNeighbors(gcq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// QueryRelease chains the current query on the "release" edge.
func (gcq *GitCommitQuery) QueryRelease() *ReleaseQuery {
	query := &ReleaseQuery{config: gcq.config}
	query.path = func(ctx context.Context) (fromU *sql.Selector, err error) {
		if err := gcq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		selector := gcq.sqlQuery(ctx)
		if err := selector.Err(); err != nil {
			return nil, err
		}
		step := sqlgraph.NewStep(
			sqlgraph.From(gitcommit.Table, gitcommit.FieldID, selector),
			sqlgraph.To(release.Table, release.FieldID),
			sqlgraph.Edge(sqlgraph.O2O, false, gitcommit.ReleaseTable, gitcommit.ReleaseColumn),
		)
		fromU = sqlgraph.SetNeighbors(gcq.driver.Dialect(), step)
		return fromU, nil
	}
	return query
}

// First returns the first GitCommit entity from the query.
// Returns a *NotFoundError when no GitCommit was found.
func (gcq *GitCommitQuery) First(ctx context.Context) (*GitCommit, error) {
	nodes, err := gcq.Limit(1).All(ctx)
	if err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nil, &NotFoundError{gitcommit.Label}
	}
	return nodes[0], nil
}

// FirstX is like First, but panics if an error occurs.
func (gcq *GitCommitQuery) FirstX(ctx context.Context) *GitCommit {
	node, err := gcq.First(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return node
}

// FirstID returns the first GitCommit ID from the query.
// Returns a *NotFoundError when no GitCommit ID was found.
func (gcq *GitCommitQuery) FirstID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = gcq.Limit(1).IDs(ctx); err != nil {
		return
	}
	if len(ids) == 0 {
		err = &NotFoundError{gitcommit.Label}
		return
	}
	return ids[0], nil
}

// FirstIDX is like FirstID, but panics if an error occurs.
func (gcq *GitCommitQuery) FirstIDX(ctx context.Context) int {
	id, err := gcq.FirstID(ctx)
	if err != nil && !IsNotFound(err) {
		panic(err)
	}
	return id
}

// Only returns a single GitCommit entity found by the query, ensuring it only returns one.
// Returns a *NotSingularError when exactly one GitCommit entity is not found.
// Returns a *NotFoundError when no GitCommit entities are found.
func (gcq *GitCommitQuery) Only(ctx context.Context) (*GitCommit, error) {
	nodes, err := gcq.Limit(2).All(ctx)
	if err != nil {
		return nil, err
	}
	switch len(nodes) {
	case 1:
		return nodes[0], nil
	case 0:
		return nil, &NotFoundError{gitcommit.Label}
	default:
		return nil, &NotSingularError{gitcommit.Label}
	}
}

// OnlyX is like Only, but panics if an error occurs.
func (gcq *GitCommitQuery) OnlyX(ctx context.Context) *GitCommit {
	node, err := gcq.Only(ctx)
	if err != nil {
		panic(err)
	}
	return node
}

// OnlyID is like Only, but returns the only GitCommit ID in the query.
// Returns a *NotSingularError when exactly one GitCommit ID is not found.
// Returns a *NotFoundError when no entities are found.
func (gcq *GitCommitQuery) OnlyID(ctx context.Context) (id int, err error) {
	var ids []int
	if ids, err = gcq.Limit(2).IDs(ctx); err != nil {
		return
	}
	switch len(ids) {
	case 1:
		id = ids[0]
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = &NotSingularError{gitcommit.Label}
	}
	return
}

// OnlyIDX is like OnlyID, but panics if an error occurs.
func (gcq *GitCommitQuery) OnlyIDX(ctx context.Context) int {
	id, err := gcq.OnlyID(ctx)
	if err != nil {
		panic(err)
	}
	return id
}

// All executes the query and returns a list of GitCommits.
func (gcq *GitCommitQuery) All(ctx context.Context) ([]*GitCommit, error) {
	if err := gcq.prepareQuery(ctx); err != nil {
		return nil, err
	}
	return gcq.sqlAll(ctx)
}

// AllX is like All, but panics if an error occurs.
func (gcq *GitCommitQuery) AllX(ctx context.Context) []*GitCommit {
	nodes, err := gcq.All(ctx)
	if err != nil {
		panic(err)
	}
	return nodes
}

// IDs executes the query and returns a list of GitCommit IDs.
func (gcq *GitCommitQuery) IDs(ctx context.Context) ([]int, error) {
	var ids []int
	if err := gcq.Select(gitcommit.FieldID).Scan(ctx, &ids); err != nil {
		return nil, err
	}
	return ids, nil
}

// IDsX is like IDs, but panics if an error occurs.
func (gcq *GitCommitQuery) IDsX(ctx context.Context) []int {
	ids, err := gcq.IDs(ctx)
	if err != nil {
		panic(err)
	}
	return ids
}

// Count returns the count of the given query.
func (gcq *GitCommitQuery) Count(ctx context.Context) (int, error) {
	if err := gcq.prepareQuery(ctx); err != nil {
		return 0, err
	}
	return gcq.sqlCount(ctx)
}

// CountX is like Count, but panics if an error occurs.
func (gcq *GitCommitQuery) CountX(ctx context.Context) int {
	count, err := gcq.Count(ctx)
	if err != nil {
		panic(err)
	}
	return count
}

// Exist returns true if the query has elements in the graph.
func (gcq *GitCommitQuery) Exist(ctx context.Context) (bool, error) {
	if err := gcq.prepareQuery(ctx); err != nil {
		return false, err
	}
	return gcq.sqlExist(ctx)
}

// ExistX is like Exist, but panics if an error occurs.
func (gcq *GitCommitQuery) ExistX(ctx context.Context) bool {
	exist, err := gcq.Exist(ctx)
	if err != nil {
		panic(err)
	}
	return exist
}

// Clone returns a duplicate of the GitCommitQuery builder, including all associated steps. It can be
// used to prepare common query builders and use them differently after the clone is made.
func (gcq *GitCommitQuery) Clone() *GitCommitQuery {
	if gcq == nil {
		return nil
	}
	return &GitCommitQuery{
		config:      gcq.config,
		limit:       gcq.limit,
		offset:      gcq.offset,
		order:       append([]OrderFunc{}, gcq.order...),
		predicates:  append([]predicate.GitCommit{}, gcq.predicates...),
		withRepo:    gcq.withRepo.Clone(),
		withRelease: gcq.withRelease.Clone(),
		// clone intermediate query.
		sql:  gcq.sql.Clone(),
		path: gcq.path,
	}
}

// WithRepo tells the query-builder to eager-load the nodes that are connected to
// the "repo" edge. The optional arguments are used to configure the query builder of the edge.
func (gcq *GitCommitQuery) WithRepo(opts ...func(*RepoQuery)) *GitCommitQuery {
	query := &RepoQuery{config: gcq.config}
	for _, opt := range opts {
		opt(query)
	}
	gcq.withRepo = query
	return gcq
}

// WithRelease tells the query-builder to eager-load the nodes that are connected to
// the "release" edge. The optional arguments are used to configure the query builder of the edge.
func (gcq *GitCommitQuery) WithRelease(opts ...func(*ReleaseQuery)) *GitCommitQuery {
	query := &ReleaseQuery{config: gcq.config}
	for _, opt := range opts {
		opt(query)
	}
	gcq.withRelease = query
	return gcq
}

// GroupBy is used to group vertices by one or more fields/columns.
// It is often used with aggregate functions, like: count, max, mean, min, sum.
//
// Example:
//
//	var v []struct {
//		Hash string `json:"hash,omitempty"`
//		Count int `json:"count,omitempty"`
//	}
//
//	client.GitCommit.Query().
//		GroupBy(gitcommit.FieldHash).
//		Aggregate(ent.Count()).
//		Scan(ctx, &v)
//
func (gcq *GitCommitQuery) GroupBy(field string, fields ...string) *GitCommitGroupBy {
	group := &GitCommitGroupBy{config: gcq.config}
	group.fields = append([]string{field}, fields...)
	group.path = func(ctx context.Context) (prev *sql.Selector, err error) {
		if err := gcq.prepareQuery(ctx); err != nil {
			return nil, err
		}
		return gcq.sqlQuery(ctx), nil
	}
	return group
}

// Select allows the selection one or more fields/columns for the given query,
// instead of selecting all fields in the entity.
//
// Example:
//
//	var v []struct {
//		Hash string `json:"hash,omitempty"`
//	}
//
//	client.GitCommit.Query().
//		Select(gitcommit.FieldHash).
//		Scan(ctx, &v)
//
func (gcq *GitCommitQuery) Select(fields ...string) *GitCommitSelect {
	gcq.fields = append(gcq.fields, fields...)
	return &GitCommitSelect{GitCommitQuery: gcq}
}

func (gcq *GitCommitQuery) prepareQuery(ctx context.Context) error {
	for _, f := range gcq.fields {
		if !gitcommit.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("ent: invalid field %q for query", f)}
		}
	}
	if gcq.path != nil {
		prev, err := gcq.path(ctx)
		if err != nil {
			return err
		}
		gcq.sql = prev
	}
	return nil
}

func (gcq *GitCommitQuery) sqlAll(ctx context.Context) ([]*GitCommit, error) {
	var (
		nodes       = []*GitCommit{}
		withFKs     = gcq.withFKs
		_spec       = gcq.querySpec()
		loadedTypes = [2]bool{
			gcq.withRepo != nil,
			gcq.withRelease != nil,
		}
	)
	if gcq.withRepo != nil {
		withFKs = true
	}
	if withFKs {
		_spec.Node.Columns = append(_spec.Node.Columns, gitcommit.ForeignKeys...)
	}
	_spec.ScanValues = func(columns []string) ([]interface{}, error) {
		node := &GitCommit{config: gcq.config}
		nodes = append(nodes, node)
		return node.scanValues(columns)
	}
	_spec.Assign = func(columns []string, values []interface{}) error {
		if len(nodes) == 0 {
			return fmt.Errorf("ent: Assign called without calling ScanValues")
		}
		node := nodes[len(nodes)-1]
		node.Edges.loadedTypes = loadedTypes
		return node.assignValues(columns, values)
	}
	if err := sqlgraph.QueryNodes(ctx, gcq.driver, _spec); err != nil {
		return nil, err
	}
	if len(nodes) == 0 {
		return nodes, nil
	}

	if query := gcq.withRepo; query != nil {
		ids := make([]int, 0, len(nodes))
		nodeids := make(map[int][]*GitCommit)
		for i := range nodes {
			if nodes[i].git_commit_repo == nil {
				continue
			}
			fk := *nodes[i].git_commit_repo
			if _, ok := nodeids[fk]; !ok {
				ids = append(ids, fk)
			}
			nodeids[fk] = append(nodeids[fk], nodes[i])
		}
		query.Where(repo.IDIn(ids...))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			nodes, ok := nodeids[n.ID]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "git_commit_repo" returned %v`, n.ID)
			}
			for i := range nodes {
				nodes[i].Edges.Repo = n
			}
		}
	}

	if query := gcq.withRelease; query != nil {
		fks := make([]driver.Value, 0, len(nodes))
		nodeids := make(map[int]*GitCommit)
		for i := range nodes {
			fks = append(fks, nodes[i].ID)
			nodeids[nodes[i].ID] = nodes[i]
		}
		query.withFKs = true
		query.Where(predicate.Release(func(s *sql.Selector) {
			s.Where(sql.InValues(gitcommit.ReleaseColumn, fks...))
		}))
		neighbors, err := query.All(ctx)
		if err != nil {
			return nil, err
		}
		for _, n := range neighbors {
			fk := n.git_commit_release
			if fk == nil {
				return nil, fmt.Errorf(`foreign-key "git_commit_release" is nil for node %v`, n.ID)
			}
			node, ok := nodeids[*fk]
			if !ok {
				return nil, fmt.Errorf(`unexpected foreign-key "git_commit_release" returned %v for node %v`, *fk, n.ID)
			}
			node.Edges.Release = n
		}
	}

	return nodes, nil
}

func (gcq *GitCommitQuery) sqlCount(ctx context.Context) (int, error) {
	_spec := gcq.querySpec()
	return sqlgraph.CountNodes(ctx, gcq.driver, _spec)
}

func (gcq *GitCommitQuery) sqlExist(ctx context.Context) (bool, error) {
	n, err := gcq.sqlCount(ctx)
	if err != nil {
		return false, fmt.Errorf("ent: check existence: %w", err)
	}
	return n > 0, nil
}

func (gcq *GitCommitQuery) querySpec() *sqlgraph.QuerySpec {
	_spec := &sqlgraph.QuerySpec{
		Node: &sqlgraph.NodeSpec{
			Table:   gitcommit.Table,
			Columns: gitcommit.Columns,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: gitcommit.FieldID,
			},
		},
		From:   gcq.sql,
		Unique: true,
	}
	if unique := gcq.unique; unique != nil {
		_spec.Unique = *unique
	}
	if fields := gcq.fields; len(fields) > 0 {
		_spec.Node.Columns = make([]string, 0, len(fields))
		_spec.Node.Columns = append(_spec.Node.Columns, gitcommit.FieldID)
		for i := range fields {
			if fields[i] != gitcommit.FieldID {
				_spec.Node.Columns = append(_spec.Node.Columns, fields[i])
			}
		}
	}
	if ps := gcq.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	if limit := gcq.limit; limit != nil {
		_spec.Limit = *limit
	}
	if offset := gcq.offset; offset != nil {
		_spec.Offset = *offset
	}
	if ps := gcq.order; len(ps) > 0 {
		_spec.Order = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return _spec
}

func (gcq *GitCommitQuery) sqlQuery(ctx context.Context) *sql.Selector {
	builder := sql.Dialect(gcq.driver.Dialect())
	t1 := builder.Table(gitcommit.Table)
	columns := gcq.fields
	if len(columns) == 0 {
		columns = gitcommit.Columns
	}
	selector := builder.Select(t1.Columns(columns...)...).From(t1)
	if gcq.sql != nil {
		selector = gcq.sql
		selector.Select(selector.Columns(columns...)...)
	}
	for _, p := range gcq.predicates {
		p(selector)
	}
	for _, p := range gcq.order {
		p(selector)
	}
	if offset := gcq.offset; offset != nil {
		// limit is mandatory for offset clause. We start
		// with default value, and override it below if needed.
		selector.Offset(*offset).Limit(math.MaxInt32)
	}
	if limit := gcq.limit; limit != nil {
		selector.Limit(*limit)
	}
	return selector
}

// GitCommitGroupBy is the group-by builder for GitCommit entities.
type GitCommitGroupBy struct {
	config
	fields []string
	fns    []AggregateFunc
	// intermediate query (i.e. traversal path).
	sql  *sql.Selector
	path func(context.Context) (*sql.Selector, error)
}

// Aggregate adds the given aggregation functions to the group-by query.
func (gcgb *GitCommitGroupBy) Aggregate(fns ...AggregateFunc) *GitCommitGroupBy {
	gcgb.fns = append(gcgb.fns, fns...)
	return gcgb
}

// Scan applies the group-by query and scans the result into the given value.
func (gcgb *GitCommitGroupBy) Scan(ctx context.Context, v interface{}) error {
	query, err := gcgb.path(ctx)
	if err != nil {
		return err
	}
	gcgb.sql = query
	return gcgb.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) ScanX(ctx context.Context, v interface{}) {
	if err := gcgb.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from group-by.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Strings(ctx context.Context) ([]string, error) {
	if len(gcgb.fields) > 1 {
		return nil, errors.New("ent: GitCommitGroupBy.Strings is not achievable when grouping more than 1 field")
	}
	var v []string
	if err := gcgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) StringsX(ctx context.Context) []string {
	v, err := gcgb.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = gcgb.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitGroupBy.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) StringX(ctx context.Context) string {
	v, err := gcgb.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from group-by.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Ints(ctx context.Context) ([]int, error) {
	if len(gcgb.fields) > 1 {
		return nil, errors.New("ent: GitCommitGroupBy.Ints is not achievable when grouping more than 1 field")
	}
	var v []int
	if err := gcgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) IntsX(ctx context.Context) []int {
	v, err := gcgb.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = gcgb.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitGroupBy.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) IntX(ctx context.Context) int {
	v, err := gcgb.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from group-by.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Float64s(ctx context.Context) ([]float64, error) {
	if len(gcgb.fields) > 1 {
		return nil, errors.New("ent: GitCommitGroupBy.Float64s is not achievable when grouping more than 1 field")
	}
	var v []float64
	if err := gcgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) Float64sX(ctx context.Context) []float64 {
	v, err := gcgb.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = gcgb.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitGroupBy.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) Float64X(ctx context.Context) float64 {
	v, err := gcgb.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from group-by.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Bools(ctx context.Context) ([]bool, error) {
	if len(gcgb.fields) > 1 {
		return nil, errors.New("ent: GitCommitGroupBy.Bools is not achievable when grouping more than 1 field")
	}
	var v []bool
	if err := gcgb.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) BoolsX(ctx context.Context) []bool {
	v, err := gcgb.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a group-by query.
// It is only allowed when executing a group-by query with one field.
func (gcgb *GitCommitGroupBy) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = gcgb.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitGroupBy.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (gcgb *GitCommitGroupBy) BoolX(ctx context.Context) bool {
	v, err := gcgb.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (gcgb *GitCommitGroupBy) sqlScan(ctx context.Context, v interface{}) error {
	for _, f := range gcgb.fields {
		if !gitcommit.ValidColumn(f) {
			return &ValidationError{Name: f, err: fmt.Errorf("invalid field %q for group-by", f)}
		}
	}
	selector := gcgb.sqlQuery()
	if err := selector.Err(); err != nil {
		return err
	}
	rows := &sql.Rows{}
	query, args := selector.Query()
	if err := gcgb.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}

func (gcgb *GitCommitGroupBy) sqlQuery() *sql.Selector {
	selector := gcgb.sql.Select()
	aggregation := make([]string, 0, len(gcgb.fns))
	for _, fn := range gcgb.fns {
		aggregation = append(aggregation, fn(selector))
	}
	// If no columns were selected in a custom aggregation function, the default
	// selection is the fields used for "group-by", and the aggregation functions.
	if len(selector.SelectedColumns()) == 0 {
		columns := make([]string, 0, len(gcgb.fields)+len(gcgb.fns))
		for _, f := range gcgb.fields {
			columns = append(columns, selector.C(f))
		}
		for _, c := range aggregation {
			columns = append(columns, c)
		}
		selector.Select(columns...)
	}
	return selector.GroupBy(selector.Columns(gcgb.fields...)...)
}

// GitCommitSelect is the builder for selecting fields of GitCommit entities.
type GitCommitSelect struct {
	*GitCommitQuery
	// intermediate query (i.e. traversal path).
	sql *sql.Selector
}

// Scan applies the selector query and scans the result into the given value.
func (gcs *GitCommitSelect) Scan(ctx context.Context, v interface{}) error {
	if err := gcs.prepareQuery(ctx); err != nil {
		return err
	}
	gcs.sql = gcs.GitCommitQuery.sqlQuery(ctx)
	return gcs.sqlScan(ctx, v)
}

// ScanX is like Scan, but panics if an error occurs.
func (gcs *GitCommitSelect) ScanX(ctx context.Context, v interface{}) {
	if err := gcs.Scan(ctx, v); err != nil {
		panic(err)
	}
}

// Strings returns list of strings from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Strings(ctx context.Context) ([]string, error) {
	if len(gcs.fields) > 1 {
		return nil, errors.New("ent: GitCommitSelect.Strings is not achievable when selecting more than 1 field")
	}
	var v []string
	if err := gcs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// StringsX is like Strings, but panics if an error occurs.
func (gcs *GitCommitSelect) StringsX(ctx context.Context) []string {
	v, err := gcs.Strings(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// String returns a single string from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) String(ctx context.Context) (_ string, err error) {
	var v []string
	if v, err = gcs.Strings(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitSelect.Strings returned %d results when one was expected", len(v))
	}
	return
}

// StringX is like String, but panics if an error occurs.
func (gcs *GitCommitSelect) StringX(ctx context.Context) string {
	v, err := gcs.String(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Ints returns list of ints from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Ints(ctx context.Context) ([]int, error) {
	if len(gcs.fields) > 1 {
		return nil, errors.New("ent: GitCommitSelect.Ints is not achievable when selecting more than 1 field")
	}
	var v []int
	if err := gcs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// IntsX is like Ints, but panics if an error occurs.
func (gcs *GitCommitSelect) IntsX(ctx context.Context) []int {
	v, err := gcs.Ints(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Int returns a single int from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Int(ctx context.Context) (_ int, err error) {
	var v []int
	if v, err = gcs.Ints(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitSelect.Ints returned %d results when one was expected", len(v))
	}
	return
}

// IntX is like Int, but panics if an error occurs.
func (gcs *GitCommitSelect) IntX(ctx context.Context) int {
	v, err := gcs.Int(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64s returns list of float64s from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Float64s(ctx context.Context) ([]float64, error) {
	if len(gcs.fields) > 1 {
		return nil, errors.New("ent: GitCommitSelect.Float64s is not achievable when selecting more than 1 field")
	}
	var v []float64
	if err := gcs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// Float64sX is like Float64s, but panics if an error occurs.
func (gcs *GitCommitSelect) Float64sX(ctx context.Context) []float64 {
	v, err := gcs.Float64s(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Float64 returns a single float64 from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Float64(ctx context.Context) (_ float64, err error) {
	var v []float64
	if v, err = gcs.Float64s(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitSelect.Float64s returned %d results when one was expected", len(v))
	}
	return
}

// Float64X is like Float64, but panics if an error occurs.
func (gcs *GitCommitSelect) Float64X(ctx context.Context) float64 {
	v, err := gcs.Float64(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bools returns list of bools from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Bools(ctx context.Context) ([]bool, error) {
	if len(gcs.fields) > 1 {
		return nil, errors.New("ent: GitCommitSelect.Bools is not achievable when selecting more than 1 field")
	}
	var v []bool
	if err := gcs.Scan(ctx, &v); err != nil {
		return nil, err
	}
	return v, nil
}

// BoolsX is like Bools, but panics if an error occurs.
func (gcs *GitCommitSelect) BoolsX(ctx context.Context) []bool {
	v, err := gcs.Bools(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

// Bool returns a single bool from a selector. It is only allowed when selecting one field.
func (gcs *GitCommitSelect) Bool(ctx context.Context) (_ bool, err error) {
	var v []bool
	if v, err = gcs.Bools(ctx); err != nil {
		return
	}
	switch len(v) {
	case 1:
		return v[0], nil
	case 0:
		err = &NotFoundError{gitcommit.Label}
	default:
		err = fmt.Errorf("ent: GitCommitSelect.Bools returned %d results when one was expected", len(v))
	}
	return
}

// BoolX is like Bool, but panics if an error occurs.
func (gcs *GitCommitSelect) BoolX(ctx context.Context) bool {
	v, err := gcs.Bool(ctx)
	if err != nil {
		panic(err)
	}
	return v
}

func (gcs *GitCommitSelect) sqlScan(ctx context.Context, v interface{}) error {
	rows := &sql.Rows{}
	query, args := gcs.sql.Query()
	if err := gcs.driver.Query(ctx, query, args, rows); err != nil {
		return err
	}
	defer rows.Close()
	return sql.ScanSlice(rows, v)
}
