// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"encoding/json"
	"fmt"
	"sync"
	"sync/atomic"

	"entgo.io/contrib/entgql"
	"entgo.io/ent/dialect"
	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/schema"
	"github.com/99designs/gqlgen/graphql"
	"github.com/hashicorp/go-multierror"
	"github.com/valocode/bubbly/ent/adapter"
	"github.com/valocode/bubbly/ent/artifact"
	"github.com/valocode/bubbly/ent/codeissue"
	"github.com/valocode/bubbly/ent/codescan"
	"github.com/valocode/bubbly/ent/component"
	"github.com/valocode/bubbly/ent/gitcommit"
	"github.com/valocode/bubbly/ent/license"
	"github.com/valocode/bubbly/ent/licenseuse"
	"github.com/valocode/bubbly/ent/organization"
	"github.com/valocode/bubbly/ent/project"
	"github.com/valocode/bubbly/ent/release"
	"github.com/valocode/bubbly/ent/releasecomponent"
	"github.com/valocode/bubbly/ent/releaseentry"
	"github.com/valocode/bubbly/ent/releaselicense"
	"github.com/valocode/bubbly/ent/releasepolicy"
	"github.com/valocode/bubbly/ent/releasepolicyviolation"
	"github.com/valocode/bubbly/ent/releasevulnerability"
	"github.com/valocode/bubbly/ent/repo"
	"github.com/valocode/bubbly/ent/testcase"
	"github.com/valocode/bubbly/ent/testrun"
	"github.com/valocode/bubbly/ent/vulnerability"
	"github.com/valocode/bubbly/ent/vulnerabilityreview"
	"golang.org/x/sync/semaphore"
)

// Noder wraps the basic Node method.
type Noder interface {
	Node(context.Context) (*Node, error)
}

// Node in the graph.
type Node struct {
	ID     int      `json:"id,omitempty"`     // node id.
	Type   string   `json:"type,omitempty"`   // node type.
	Fields []*Field `json:"fields,omitempty"` // node fields.
	Edges  []*Edge  `json:"edges,omitempty"`  // node edges.
}

// Field of a node.
type Field struct {
	Type  string `json:"type,omitempty"`  // field type.
	Name  string `json:"name,omitempty"`  // field name (as in struct).
	Value string `json:"value,omitempty"` // stringified value.
}

// Edges between two nodes.
type Edge struct {
	Type string `json:"type,omitempty"` // edge type.
	Name string `json:"name,omitempty"` // edge name.
	IDs  []int  `json:"ids,omitempty"`  // node ids (where this edge point to).
}

func (a *Adapter) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     a.ID,
		Type:   "Adapter",
		Fields: make([]*Field, 3),
		Edges:  make([]*Edge, 1),
	}
	var buf []byte
	if buf, err = json.Marshal(a.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(a.Tag); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "tag",
		Value: string(buf),
	}
	if buf, err = json.Marshal(a.Module); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "string",
		Name:  "module",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Organization",
		Name: "owner",
	}
	err = a.QueryOwner().
		Select(organization.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (a *Artifact) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     a.ID,
		Type:   "Artifact",
		Fields: make([]*Field, 5),
		Edges:  make([]*Edge, 2),
	}
	var buf []byte
	if buf, err = json.Marshal(a.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(a.Sha256); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "sha256",
		Value: string(buf),
	}
	if buf, err = json.Marshal(a.Type); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "artifact.Type",
		Name:  "type",
		Value: string(buf),
	}
	if buf, err = json.Marshal(a.Time); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "time.Time",
		Name:  "time",
		Value: string(buf),
	}
	if buf, err = json.Marshal(a.Metadata); err != nil {
		return nil, err
	}
	node.Fields[4] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = a.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "ReleaseEntry",
		Name: "entry",
	}
	err = a.QueryEntry().
		Select(releaseentry.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (ci *CodeIssue) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     ci.ID,
		Type:   "CodeIssue",
		Fields: make([]*Field, 5),
		Edges:  make([]*Edge, 1),
	}
	var buf []byte
	if buf, err = json.Marshal(ci.RuleID); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "rule_id",
		Value: string(buf),
	}
	if buf, err = json.Marshal(ci.Message); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "message",
		Value: string(buf),
	}
	if buf, err = json.Marshal(ci.Severity); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "codeissue.Severity",
		Name:  "severity",
		Value: string(buf),
	}
	if buf, err = json.Marshal(ci.Type); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "codeissue.Type",
		Name:  "type",
		Value: string(buf),
	}
	if buf, err = json.Marshal(ci.Metadata); err != nil {
		return nil, err
	}
	node.Fields[4] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "CodeScan",
		Name: "scan",
	}
	err = ci.QueryScan().
		Select(codescan.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (cs *CodeScan) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     cs.ID,
		Type:   "CodeScan",
		Fields: make([]*Field, 3),
		Edges:  make([]*Edge, 5),
	}
	var buf []byte
	if buf, err = json.Marshal(cs.Tool); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "tool",
		Value: string(buf),
	}
	if buf, err = json.Marshal(cs.Time); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "time.Time",
		Name:  "time",
		Value: string(buf),
	}
	if buf, err = json.Marshal(cs.Metadata); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = cs.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "ReleaseEntry",
		Name: "entry",
	}
	err = cs.QueryEntry().
		Select(releaseentry.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "CodeIssue",
		Name: "issues",
	}
	err = cs.QueryIssues().
		Select(codeissue.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "ReleaseVulnerability",
		Name: "vulnerabilities",
	}
	err = cs.QueryVulnerabilities().
		Select(releasevulnerability.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[4] = &Edge{
		Type: "ReleaseComponent",
		Name: "components",
	}
	err = cs.QueryComponents().
		Select(releasecomponent.FieldID).
		Scan(ctx, &node.Edges[4].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (c *Component) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     c.ID,
		Type:   "Component",
		Fields: make([]*Field, 6),
		Edges:  make([]*Edge, 4),
	}
	var buf []byte
	if buf, err = json.Marshal(c.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(c.Vendor); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "vendor",
		Value: string(buf),
	}
	if buf, err = json.Marshal(c.Version); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "string",
		Name:  "version",
		Value: string(buf),
	}
	if buf, err = json.Marshal(c.Description); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "string",
		Name:  "description",
		Value: string(buf),
	}
	if buf, err = json.Marshal(c.URL); err != nil {
		return nil, err
	}
	node.Fields[4] = &Field{
		Type:  "string",
		Name:  "url",
		Value: string(buf),
	}
	if buf, err = json.Marshal(c.Metadata); err != nil {
		return nil, err
	}
	node.Fields[5] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Organization",
		Name: "owner",
	}
	err = c.QueryOwner().
		Select(organization.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Vulnerability",
		Name: "vulnerabilities",
	}
	err = c.QueryVulnerabilities().
		Select(vulnerability.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "License",
		Name: "licenses",
	}
	err = c.QueryLicenses().
		Select(license.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "ReleaseComponent",
		Name: "uses",
	}
	err = c.QueryUses().
		Select(releasecomponent.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (gc *GitCommit) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     gc.ID,
		Type:   "GitCommit",
		Fields: make([]*Field, 4),
		Edges:  make([]*Edge, 2),
	}
	var buf []byte
	if buf, err = json.Marshal(gc.Hash); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "hash",
		Value: string(buf),
	}
	if buf, err = json.Marshal(gc.Branch); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "branch",
		Value: string(buf),
	}
	if buf, err = json.Marshal(gc.Tag); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "string",
		Name:  "tag",
		Value: string(buf),
	}
	if buf, err = json.Marshal(gc.Time); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "time.Time",
		Name:  "time",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Repo",
		Name: "repo",
	}
	err = gc.QueryRepo().
		Select(repo.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = gc.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (l *License) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     l.ID,
		Type:   "License",
		Fields: make([]*Field, 5),
		Edges:  make([]*Edge, 2),
	}
	var buf []byte
	if buf, err = json.Marshal(l.SpdxID); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "spdx_id",
		Value: string(buf),
	}
	if buf, err = json.Marshal(l.Name); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(l.Reference); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "string",
		Name:  "reference",
		Value: string(buf),
	}
	if buf, err = json.Marshal(l.DetailsURL); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "string",
		Name:  "details_url",
		Value: string(buf),
	}
	if buf, err = json.Marshal(l.IsOsiApproved); err != nil {
		return nil, err
	}
	node.Fields[4] = &Field{
		Type:  "bool",
		Name:  "is_osi_approved",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Component",
		Name: "components",
	}
	err = l.QueryComponents().
		Select(component.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "LicenseUse",
		Name: "uses",
	}
	err = l.QueryUses().
		Select(licenseuse.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (lu *LicenseUse) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     lu.ID,
		Type:   "LicenseUse",
		Fields: make([]*Field, 0),
		Edges:  make([]*Edge, 1),
	}
	node.Edges[0] = &Edge{
		Type: "License",
		Name: "license",
	}
	err = lu.QueryLicense().
		Select(license.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (o *Organization) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     o.ID,
		Type:   "Organization",
		Fields: make([]*Field, 1),
		Edges:  make([]*Edge, 2),
	}
	var buf []byte
	if buf, err = json.Marshal(o.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Project",
		Name: "projects",
	}
	err = o.QueryProjects().
		Select(project.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Repo",
		Name: "repos",
	}
	err = o.QueryRepos().
		Select(repo.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (pr *Project) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     pr.ID,
		Type:   "Project",
		Fields: make([]*Field, 1),
		Edges:  make([]*Edge, 4),
	}
	var buf []byte
	if buf, err = json.Marshal(pr.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Organization",
		Name: "owner",
	}
	err = pr.QueryOwner().
		Select(organization.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Repo",
		Name: "repos",
	}
	err = pr.QueryRepos().
		Select(repo.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "VulnerabilityReview",
		Name: "vulnerability_reviews",
	}
	err = pr.QueryVulnerabilityReviews().
		Select(vulnerabilityreview.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "ReleasePolicy",
		Name: "policies",
	}
	err = pr.QueryPolicies().
		Select(releasepolicy.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (r *Release) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     r.ID,
		Type:   "Release",
		Fields: make([]*Field, 3),
		Edges:  make([]*Edge, 12),
	}
	var buf []byte
	if buf, err = json.Marshal(r.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(r.Version); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "version",
		Value: string(buf),
	}
	if buf, err = json.Marshal(r.Status); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "release.Status",
		Name:  "status",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Release",
		Name: "subreleases",
	}
	err = r.QuerySubreleases().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Release",
		Name: "dependencies",
	}
	err = r.QueryDependencies().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "GitCommit",
		Name: "commit",
	}
	err = r.QueryCommit().
		Select(gitcommit.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "Repo",
		Name: "head_of",
	}
	err = r.QueryHeadOf().
		Select(repo.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[4] = &Edge{
		Type: "ReleaseEntry",
		Name: "log",
	}
	err = r.QueryLog().
		Select(releaseentry.FieldID).
		Scan(ctx, &node.Edges[4].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[5] = &Edge{
		Type: "ReleasePolicyViolation",
		Name: "violations",
	}
	err = r.QueryViolations().
		Select(releasepolicyviolation.FieldID).
		Scan(ctx, &node.Edges[5].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[6] = &Edge{
		Type: "Artifact",
		Name: "artifacts",
	}
	err = r.QueryArtifacts().
		Select(artifact.FieldID).
		Scan(ctx, &node.Edges[6].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[7] = &Edge{
		Type: "ReleaseComponent",
		Name: "components",
	}
	err = r.QueryComponents().
		Select(releasecomponent.FieldID).
		Scan(ctx, &node.Edges[7].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[8] = &Edge{
		Type: "ReleaseVulnerability",
		Name: "vulnerabilities",
	}
	err = r.QueryVulnerabilities().
		Select(releasevulnerability.FieldID).
		Scan(ctx, &node.Edges[8].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[9] = &Edge{
		Type: "CodeScan",
		Name: "code_scans",
	}
	err = r.QueryCodeScans().
		Select(codescan.FieldID).
		Scan(ctx, &node.Edges[9].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[10] = &Edge{
		Type: "TestRun",
		Name: "test_runs",
	}
	err = r.QueryTestRuns().
		Select(testrun.FieldID).
		Scan(ctx, &node.Edges[10].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[11] = &Edge{
		Type: "VulnerabilityReview",
		Name: "vulnerability_reviews",
	}
	err = r.QueryVulnerabilityReviews().
		Select(vulnerabilityreview.FieldID).
		Scan(ctx, &node.Edges[11].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (rc *ReleaseComponent) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     rc.ID,
		Type:   "ReleaseComponent",
		Fields: make([]*Field, 1),
		Edges:  make([]*Edge, 4),
	}
	var buf []byte
	if buf, err = json.Marshal(rc.Type); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "releasecomponent.Type",
		Name:  "type",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = rc.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "CodeScan",
		Name: "scans",
	}
	err = rc.QueryScans().
		Select(codescan.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "Component",
		Name: "component",
	}
	err = rc.QueryComponent().
		Select(component.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "ReleaseVulnerability",
		Name: "vulnerabilities",
	}
	err = rc.QueryVulnerabilities().
		Select(releasevulnerability.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (re *ReleaseEntry) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     re.ID,
		Type:   "ReleaseEntry",
		Fields: make([]*Field, 2),
		Edges:  make([]*Edge, 4),
	}
	var buf []byte
	if buf, err = json.Marshal(re.Type); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "releaseentry.Type",
		Name:  "type",
		Value: string(buf),
	}
	if buf, err = json.Marshal(re.Time); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "time.Time",
		Name:  "time",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Artifact",
		Name: "artifact",
	}
	err = re.QueryArtifact().
		Select(artifact.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "CodeScan",
		Name: "code_scan",
	}
	err = re.QueryCodeScan().
		Select(codescan.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "TestRun",
		Name: "test_run",
	}
	err = re.QueryTestRun().
		Select(testrun.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = re.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (rl *ReleaseLicense) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     rl.ID,
		Type:   "ReleaseLicense",
		Fields: make([]*Field, 0),
		Edges:  make([]*Edge, 4),
	}
	node.Edges[0] = &Edge{
		Type: "License",
		Name: "license",
	}
	err = rl.QueryLicense().
		Select(license.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "ReleaseComponent",
		Name: "component",
	}
	err = rl.QueryComponent().
		Select(releasecomponent.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = rl.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "CodeScan",
		Name: "scans",
	}
	err = rl.QueryScans().
		Select(codescan.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (rp *ReleasePolicy) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     rp.ID,
		Type:   "ReleasePolicy",
		Fields: make([]*Field, 2),
		Edges:  make([]*Edge, 4),
	}
	var buf []byte
	if buf, err = json.Marshal(rp.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(rp.Module); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "module",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Organization",
		Name: "owner",
	}
	err = rp.QueryOwner().
		Select(organization.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Project",
		Name: "projects",
	}
	err = rp.QueryProjects().
		Select(project.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "Repo",
		Name: "repos",
	}
	err = rp.QueryRepos().
		Select(repo.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "ReleasePolicyViolation",
		Name: "violations",
	}
	err = rp.QueryViolations().
		Select(releasepolicyviolation.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (rpv *ReleasePolicyViolation) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     rpv.ID,
		Type:   "ReleasePolicyViolation",
		Fields: make([]*Field, 3),
		Edges:  make([]*Edge, 2),
	}
	var buf []byte
	if buf, err = json.Marshal(rpv.Message); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "message",
		Value: string(buf),
	}
	if buf, err = json.Marshal(rpv.Type); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "releasepolicyviolation.Type",
		Name:  "type",
		Value: string(buf),
	}
	if buf, err = json.Marshal(rpv.Severity); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "releasepolicyviolation.Severity",
		Name:  "severity",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "ReleasePolicy",
		Name: "policy",
	}
	err = rpv.QueryPolicy().
		Select(releasepolicy.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = rpv.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (rv *ReleaseVulnerability) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     rv.ID,
		Type:   "ReleaseVulnerability",
		Fields: make([]*Field, 0),
		Edges:  make([]*Edge, 5),
	}
	node.Edges[0] = &Edge{
		Type: "Vulnerability",
		Name: "vulnerability",
	}
	err = rv.QueryVulnerability().
		Select(vulnerability.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "ReleaseComponent",
		Name: "component",
	}
	err = rv.QueryComponent().
		Select(releasecomponent.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = rv.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "VulnerabilityReview",
		Name: "reviews",
	}
	err = rv.QueryReviews().
		Select(vulnerabilityreview.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[4] = &Edge{
		Type: "CodeScan",
		Name: "scan",
	}
	err = rv.QueryScan().
		Select(codescan.FieldID).
		Scan(ctx, &node.Edges[4].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (r *Repo) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     r.ID,
		Type:   "Repo",
		Fields: make([]*Field, 2),
		Edges:  make([]*Edge, 6),
	}
	var buf []byte
	if buf, err = json.Marshal(r.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(r.DefaultBranch); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "default_branch",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Organization",
		Name: "owner",
	}
	err = r.QueryOwner().
		Select(organization.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Project",
		Name: "project",
	}
	err = r.QueryProject().
		Select(project.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "Release",
		Name: "head",
	}
	err = r.QueryHead().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "GitCommit",
		Name: "commits",
	}
	err = r.QueryCommits().
		Select(gitcommit.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[4] = &Edge{
		Type: "VulnerabilityReview",
		Name: "vulnerability_reviews",
	}
	err = r.QueryVulnerabilityReviews().
		Select(vulnerabilityreview.FieldID).
		Scan(ctx, &node.Edges[4].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[5] = &Edge{
		Type: "ReleasePolicy",
		Name: "policies",
	}
	err = r.QueryPolicies().
		Select(releasepolicy.FieldID).
		Scan(ctx, &node.Edges[5].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (tc *TestCase) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     tc.ID,
		Type:   "TestCase",
		Fields: make([]*Field, 5),
		Edges:  make([]*Edge, 1),
	}
	var buf []byte
	if buf, err = json.Marshal(tc.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(tc.Result); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "bool",
		Name:  "result",
		Value: string(buf),
	}
	if buf, err = json.Marshal(tc.Message); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "string",
		Name:  "message",
		Value: string(buf),
	}
	if buf, err = json.Marshal(tc.Elapsed); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "float64",
		Name:  "elapsed",
		Value: string(buf),
	}
	if buf, err = json.Marshal(tc.Metadata); err != nil {
		return nil, err
	}
	node.Fields[4] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "TestRun",
		Name: "run",
	}
	err = tc.QueryRun().
		Select(testrun.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (tr *TestRun) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     tr.ID,
		Type:   "TestRun",
		Fields: make([]*Field, 3),
		Edges:  make([]*Edge, 3),
	}
	var buf []byte
	if buf, err = json.Marshal(tr.Tool); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "tool",
		Value: string(buf),
	}
	if buf, err = json.Marshal(tr.Time); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "time.Time",
		Name:  "time",
		Value: string(buf),
	}
	if buf, err = json.Marshal(tr.Metadata); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Release",
		Name: "release",
	}
	err = tr.QueryRelease().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "ReleaseEntry",
		Name: "entry",
	}
	err = tr.QueryEntry().
		Select(releaseentry.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "TestCase",
		Name: "tests",
	}
	err = tr.QueryTests().
		Select(testcase.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (v *Vulnerability) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     v.ID,
		Type:   "Vulnerability",
		Fields: make([]*Field, 8),
		Edges:  make([]*Edge, 4),
	}
	var buf []byte
	if buf, err = json.Marshal(v.Vid); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "vid",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.Summary); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "string",
		Name:  "summary",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.Description); err != nil {
		return nil, err
	}
	node.Fields[2] = &Field{
		Type:  "string",
		Name:  "description",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.SeverityScore); err != nil {
		return nil, err
	}
	node.Fields[3] = &Field{
		Type:  "float64",
		Name:  "severity_score",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.Severity); err != nil {
		return nil, err
	}
	node.Fields[4] = &Field{
		Type:  "vulnerability.Severity",
		Name:  "severity",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.Published); err != nil {
		return nil, err
	}
	node.Fields[5] = &Field{
		Type:  "time.Time",
		Name:  "published",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.Modified); err != nil {
		return nil, err
	}
	node.Fields[6] = &Field{
		Type:  "time.Time",
		Name:  "modified",
		Value: string(buf),
	}
	if buf, err = json.Marshal(v.Metadata); err != nil {
		return nil, err
	}
	node.Fields[7] = &Field{
		Type:  "schema.Metadata",
		Name:  "metadata",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Organization",
		Name: "owner",
	}
	err = v.QueryOwner().
		Select(organization.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Component",
		Name: "components",
	}
	err = v.QueryComponents().
		Select(component.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "VulnerabilityReview",
		Name: "reviews",
	}
	err = v.QueryReviews().
		Select(vulnerabilityreview.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "ReleaseVulnerability",
		Name: "instances",
	}
	err = v.QueryInstances().
		Select(releasevulnerability.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (vr *VulnerabilityReview) Node(ctx context.Context) (node *Node, err error) {
	node = &Node{
		ID:     vr.ID,
		Type:   "VulnerabilityReview",
		Fields: make([]*Field, 2),
		Edges:  make([]*Edge, 5),
	}
	var buf []byte
	if buf, err = json.Marshal(vr.Name); err != nil {
		return nil, err
	}
	node.Fields[0] = &Field{
		Type:  "string",
		Name:  "name",
		Value: string(buf),
	}
	if buf, err = json.Marshal(vr.Decision); err != nil {
		return nil, err
	}
	node.Fields[1] = &Field{
		Type:  "vulnerabilityreview.Decision",
		Name:  "decision",
		Value: string(buf),
	}
	node.Edges[0] = &Edge{
		Type: "Vulnerability",
		Name: "vulnerability",
	}
	err = vr.QueryVulnerability().
		Select(vulnerability.FieldID).
		Scan(ctx, &node.Edges[0].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[1] = &Edge{
		Type: "Project",
		Name: "projects",
	}
	err = vr.QueryProjects().
		Select(project.FieldID).
		Scan(ctx, &node.Edges[1].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[2] = &Edge{
		Type: "Repo",
		Name: "repos",
	}
	err = vr.QueryRepos().
		Select(repo.FieldID).
		Scan(ctx, &node.Edges[2].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[3] = &Edge{
		Type: "Release",
		Name: "releases",
	}
	err = vr.QueryReleases().
		Select(release.FieldID).
		Scan(ctx, &node.Edges[3].IDs)
	if err != nil {
		return nil, err
	}
	node.Edges[4] = &Edge{
		Type: "ReleaseVulnerability",
		Name: "instances",
	}
	err = vr.QueryInstances().
		Select(releasevulnerability.FieldID).
		Scan(ctx, &node.Edges[4].IDs)
	if err != nil {
		return nil, err
	}
	return node, nil
}

func (c *Client) Node(ctx context.Context, id int) (*Node, error) {
	n, err := c.Noder(ctx, id)
	if err != nil {
		return nil, err
	}
	return n.Node(ctx)
}

var errNodeInvalidID = &NotFoundError{"node"}

// NodeOption allows configuring the Noder execution using functional options.
type NodeOption func(*nodeOptions)

// WithNodeType sets the node Type resolver function (i.e. the table to query).
// If was not provided, the table will be derived from the universal-id
// configuration as described in: https://entgo.io/docs/migrate/#universal-ids.
func WithNodeType(f func(context.Context, int) (string, error)) NodeOption {
	return func(o *nodeOptions) {
		o.nodeType = f
	}
}

// WithFixedNodeType sets the Type of the node to a fixed value.
func WithFixedNodeType(t string) NodeOption {
	return WithNodeType(func(context.Context, int) (string, error) {
		return t, nil
	})
}

type nodeOptions struct {
	nodeType func(context.Context, int) (string, error)
}

func (c *Client) newNodeOpts(opts []NodeOption) *nodeOptions {
	nopts := &nodeOptions{}
	for _, opt := range opts {
		opt(nopts)
	}
	if nopts.nodeType == nil {
		nopts.nodeType = func(ctx context.Context, id int) (string, error) {
			return c.tables.nodeType(ctx, c.driver, id)
		}
	}
	return nopts
}

// Noder returns a Node by its id. If the NodeType was not provided, it will
// be derived from the id value according to the universal-id configuration.
//
//		c.Noder(ctx, id)
//		c.Noder(ctx, id, ent.WithNodeType(pet.Table))
//
func (c *Client) Noder(ctx context.Context, id int, opts ...NodeOption) (_ Noder, err error) {
	defer func() {
		if IsNotFound(err) {
			err = multierror.Append(err, entgql.ErrNodeNotFound(id))
		}
	}()
	table, err := c.newNodeOpts(opts).nodeType(ctx, id)
	if err != nil {
		return nil, err
	}
	return c.noder(ctx, table, id)
}

func (c *Client) noder(ctx context.Context, table string, id int) (Noder, error) {
	switch table {
	case adapter.Table:
		n, err := c.Adapter.Query().
			Where(adapter.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case artifact.Table:
		n, err := c.Artifact.Query().
			Where(artifact.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case codeissue.Table:
		n, err := c.CodeIssue.Query().
			Where(codeissue.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case codescan.Table:
		n, err := c.CodeScan.Query().
			Where(codescan.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case component.Table:
		n, err := c.Component.Query().
			Where(component.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case gitcommit.Table:
		n, err := c.GitCommit.Query().
			Where(gitcommit.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case license.Table:
		n, err := c.License.Query().
			Where(license.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case licenseuse.Table:
		n, err := c.LicenseUse.Query().
			Where(licenseuse.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case organization.Table:
		n, err := c.Organization.Query().
			Where(organization.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case project.Table:
		n, err := c.Project.Query().
			Where(project.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case release.Table:
		n, err := c.Release.Query().
			Where(release.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case releasecomponent.Table:
		n, err := c.ReleaseComponent.Query().
			Where(releasecomponent.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case releaseentry.Table:
		n, err := c.ReleaseEntry.Query().
			Where(releaseentry.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case releaselicense.Table:
		n, err := c.ReleaseLicense.Query().
			Where(releaselicense.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case releasepolicy.Table:
		n, err := c.ReleasePolicy.Query().
			Where(releasepolicy.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case releasepolicyviolation.Table:
		n, err := c.ReleasePolicyViolation.Query().
			Where(releasepolicyviolation.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case releasevulnerability.Table:
		n, err := c.ReleaseVulnerability.Query().
			Where(releasevulnerability.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case repo.Table:
		n, err := c.Repo.Query().
			Where(repo.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case testcase.Table:
		n, err := c.TestCase.Query().
			Where(testcase.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case testrun.Table:
		n, err := c.TestRun.Query().
			Where(testrun.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case vulnerability.Table:
		n, err := c.Vulnerability.Query().
			Where(vulnerability.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	case vulnerabilityreview.Table:
		n, err := c.VulnerabilityReview.Query().
			Where(vulnerabilityreview.ID(id)).
			Only(ctx)
		if err != nil {
			return nil, err
		}
		return n, nil
	default:
		return nil, fmt.Errorf("cannot resolve noder from table %q: %w", table, errNodeInvalidID)
	}
}

func (c *Client) Noders(ctx context.Context, ids []int, opts ...NodeOption) ([]Noder, error) {
	switch len(ids) {
	case 1:
		noder, err := c.Noder(ctx, ids[0], opts...)
		if err != nil {
			return nil, err
		}
		return []Noder{noder}, nil
	case 0:
		return []Noder{}, nil
	}

	noders := make([]Noder, len(ids))
	errors := make([]error, len(ids))
	tables := make(map[string][]int)
	id2idx := make(map[int][]int, len(ids))
	nopts := c.newNodeOpts(opts)
	for i, id := range ids {
		table, err := nopts.nodeType(ctx, id)
		if err != nil {
			errors[i] = err
			continue
		}
		tables[table] = append(tables[table], id)
		id2idx[id] = append(id2idx[id], i)
	}

	for table, ids := range tables {
		nodes, err := c.noders(ctx, table, ids)
		if err != nil {
			for _, id := range ids {
				for _, idx := range id2idx[id] {
					errors[idx] = err
				}
			}
		} else {
			for i, id := range ids {
				for _, idx := range id2idx[id] {
					noders[idx] = nodes[i]
				}
			}
		}
	}

	for i, id := range ids {
		if errors[i] == nil {
			if noders[i] != nil {
				continue
			}
			errors[i] = entgql.ErrNodeNotFound(id)
		} else if IsNotFound(errors[i]) {
			errors[i] = multierror.Append(errors[i], entgql.ErrNodeNotFound(id))
		}
		ctx := graphql.WithPathContext(ctx,
			graphql.NewPathWithIndex(i),
		)
		graphql.AddError(ctx, errors[i])
	}
	return noders, nil
}

func (c *Client) noders(ctx context.Context, table string, ids []int) ([]Noder, error) {
	noders := make([]Noder, len(ids))
	idmap := make(map[int][]*Noder, len(ids))
	for i, id := range ids {
		idmap[id] = append(idmap[id], &noders[i])
	}
	switch table {
	case adapter.Table:
		nodes, err := c.Adapter.Query().
			Where(adapter.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case artifact.Table:
		nodes, err := c.Artifact.Query().
			Where(artifact.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case codeissue.Table:
		nodes, err := c.CodeIssue.Query().
			Where(codeissue.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case codescan.Table:
		nodes, err := c.CodeScan.Query().
			Where(codescan.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case component.Table:
		nodes, err := c.Component.Query().
			Where(component.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case gitcommit.Table:
		nodes, err := c.GitCommit.Query().
			Where(gitcommit.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case license.Table:
		nodes, err := c.License.Query().
			Where(license.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case licenseuse.Table:
		nodes, err := c.LicenseUse.Query().
			Where(licenseuse.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case organization.Table:
		nodes, err := c.Organization.Query().
			Where(organization.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case project.Table:
		nodes, err := c.Project.Query().
			Where(project.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case release.Table:
		nodes, err := c.Release.Query().
			Where(release.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case releasecomponent.Table:
		nodes, err := c.ReleaseComponent.Query().
			Where(releasecomponent.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case releaseentry.Table:
		nodes, err := c.ReleaseEntry.Query().
			Where(releaseentry.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case releaselicense.Table:
		nodes, err := c.ReleaseLicense.Query().
			Where(releaselicense.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case releasepolicy.Table:
		nodes, err := c.ReleasePolicy.Query().
			Where(releasepolicy.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case releasepolicyviolation.Table:
		nodes, err := c.ReleasePolicyViolation.Query().
			Where(releasepolicyviolation.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case releasevulnerability.Table:
		nodes, err := c.ReleaseVulnerability.Query().
			Where(releasevulnerability.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case repo.Table:
		nodes, err := c.Repo.Query().
			Where(repo.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case testcase.Table:
		nodes, err := c.TestCase.Query().
			Where(testcase.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case testrun.Table:
		nodes, err := c.TestRun.Query().
			Where(testrun.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case vulnerability.Table:
		nodes, err := c.Vulnerability.Query().
			Where(vulnerability.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	case vulnerabilityreview.Table:
		nodes, err := c.VulnerabilityReview.Query().
			Where(vulnerabilityreview.IDIn(ids...)).
			All(ctx)
		if err != nil {
			return nil, err
		}
		for _, node := range nodes {
			for _, noder := range idmap[node.ID] {
				*noder = node
			}
		}
	default:
		return nil, fmt.Errorf("cannot resolve noders from table %q: %w", table, errNodeInvalidID)
	}
	return noders, nil
}

type tables struct {
	once  sync.Once
	sem   *semaphore.Weighted
	value atomic.Value
}

func (t *tables) nodeType(ctx context.Context, drv dialect.Driver, id int) (string, error) {
	tables, err := t.Load(ctx, drv)
	if err != nil {
		return "", err
	}
	idx := int(id / (1<<32 - 1))
	if idx < 0 || idx >= len(tables) {
		return "", fmt.Errorf("cannot resolve table from id %v: %w", id, errNodeInvalidID)
	}
	return tables[idx], nil
}

func (t *tables) Load(ctx context.Context, drv dialect.Driver) ([]string, error) {
	if tables := t.value.Load(); tables != nil {
		return tables.([]string), nil
	}
	t.once.Do(func() { t.sem = semaphore.NewWeighted(1) })
	if err := t.sem.Acquire(ctx, 1); err != nil {
		return nil, err
	}
	defer t.sem.Release(1)
	if tables := t.value.Load(); tables != nil {
		return tables.([]string), nil
	}
	tables, err := t.load(ctx, drv)
	if err == nil {
		t.value.Store(tables)
	}
	return tables, err
}

func (*tables) load(ctx context.Context, drv dialect.Driver) ([]string, error) {
	rows := &sql.Rows{}
	query, args := sql.Dialect(drv.Dialect()).
		Select("type").
		From(sql.Table(schema.TypeTable)).
		OrderBy(sql.Asc("id")).
		Query()
	if err := drv.Query(ctx, query, args, rows); err != nil {
		return nil, err
	}
	defer rows.Close()
	var tables []string
	return tables, sql.ScanSlice(rows, &tables)
}
