// Code generated by entc, DO NOT EDIT.

package ent

import (
	"context"
	"fmt"

	"entgo.io/ent/dialect/sql"
	"entgo.io/ent/dialect/sql/sqlgraph"
	"entgo.io/ent/schema/field"
	"github.com/valocode/bubbly/ent/predicate"
	"github.com/valocode/bubbly/ent/releasevulnerability"
)

// ReleaseVulnerabilityDelete is the builder for deleting a ReleaseVulnerability entity.
type ReleaseVulnerabilityDelete struct {
	config
	hooks    []Hook
	mutation *ReleaseVulnerabilityMutation
}

// Where appends a list predicates to the ReleaseVulnerabilityDelete builder.
func (rvd *ReleaseVulnerabilityDelete) Where(ps ...predicate.ReleaseVulnerability) *ReleaseVulnerabilityDelete {
	rvd.mutation.Where(ps...)
	return rvd
}

// Exec executes the deletion query and returns how many vertices were deleted.
func (rvd *ReleaseVulnerabilityDelete) Exec(ctx context.Context) (int, error) {
	var (
		err      error
		affected int
	)
	if len(rvd.hooks) == 0 {
		affected, err = rvd.sqlExec(ctx)
	} else {
		var mut Mutator = MutateFunc(func(ctx context.Context, m Mutation) (Value, error) {
			mutation, ok := m.(*ReleaseVulnerabilityMutation)
			if !ok {
				return nil, fmt.Errorf("unexpected mutation type %T", m)
			}
			rvd.mutation = mutation
			affected, err = rvd.sqlExec(ctx)
			mutation.done = true
			return affected, err
		})
		for i := len(rvd.hooks) - 1; i >= 0; i-- {
			if rvd.hooks[i] == nil {
				return 0, fmt.Errorf("ent: uninitialized hook (forgotten import ent/runtime?)")
			}
			mut = rvd.hooks[i](mut)
		}
		if _, err := mut.Mutate(ctx, rvd.mutation); err != nil {
			return 0, err
		}
	}
	return affected, err
}

// ExecX is like Exec, but panics if an error occurs.
func (rvd *ReleaseVulnerabilityDelete) ExecX(ctx context.Context) int {
	n, err := rvd.Exec(ctx)
	if err != nil {
		panic(err)
	}
	return n
}

func (rvd *ReleaseVulnerabilityDelete) sqlExec(ctx context.Context) (int, error) {
	_spec := &sqlgraph.DeleteSpec{
		Node: &sqlgraph.NodeSpec{
			Table: releasevulnerability.Table,
			ID: &sqlgraph.FieldSpec{
				Type:   field.TypeInt,
				Column: releasevulnerability.FieldID,
			},
		},
	}
	if ps := rvd.mutation.predicates; len(ps) > 0 {
		_spec.Predicate = func(selector *sql.Selector) {
			for i := range ps {
				ps[i](selector)
			}
		}
	}
	return sqlgraph.DeleteNodes(ctx, rvd.driver, _spec)
}

// ReleaseVulnerabilityDeleteOne is the builder for deleting a single ReleaseVulnerability entity.
type ReleaseVulnerabilityDeleteOne struct {
	rvd *ReleaseVulnerabilityDelete
}

// Exec executes the deletion query.
func (rvdo *ReleaseVulnerabilityDeleteOne) Exec(ctx context.Context) error {
	n, err := rvdo.rvd.Exec(ctx)
	switch {
	case err != nil:
		return err
	case n == 0:
		return &NotFoundError{releasevulnerability.Label}
	default:
		return nil
	}
}

// ExecX is like Exec, but panics if an error occurs.
func (rvdo *ReleaseVulnerabilityDeleteOne) ExecX(ctx context.Context) {
	rvdo.rvd.ExecX(ctx)
}
